#include "stm32f10x.h"
#include "led.h"

char LEDBuffer[4];
u16 LEDPins[] = {LED_D1, LED_D2, LED_D3, LED_D4};

// Digits for 7-segment LED display
//								  0     1     2     3     4     5     6     7     8     9
char digits[] = {0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8, 0x80, 0x90};

void InitLED(void)
{
	// Enable port clock
  RCC->APB2ENR |= LED_RCC;
	RCC->APB2ENR |= LED_SEL_RCC;
	
	// All pins as GP output, open-drain
	LED_PORT->CRL = 0x77777777;
  LED_PORT->CRH = 0x77777777;	
	
	LED_PORT->ODR = 0xFFFF;
	
	LED_SEL_PORT->CRH = 0x00007777;
	LED_SEL_PORT->ODR = 0x0F00;
}

// This function has to be called periodically to keep LED display
// segments light continuously
void LEDEx(void)
{
	int i, j;
	for (i = 0; i < 4; i++)
	{
		LED_PORT->ODR &= ~SEG_MASK;
		LED_PORT->ODR |= LEDBuffer[i];
		LED_SEL_PORT->ODR &= ~(1 << LEDPins[i]);
		for (j=0; j<0x3FF; j++);
		LED_SEL_PORT->ODR |= (1 << LEDPins[i]);
	}
}
