#include "stm32f10x.h"

void USART1_Init (void) 
{
  int i;

	//RCC->APB2ENR |= RCC_APB2ENR_USART1EN;
  RCC->APB2ENR |= RCC_APB2ENR_AFIOEN | RCC_APB2ENR_IOPBEN;
	
	// Remap USART1 to PB6, PB7
	AFIO->MAPR |= AFIO_MAPR_USART1_REMAP;
	
	// PB6 - tx, PB7 - rx
	GPIOB->CRL   &= ~(0xFF <<  24);
  GPIOB->CRL   |=  (0xB <<  24) | (0x4 << 28);
  
	// Enable USART2 clk
	RCC->APB2ENR |= RCC_APB2ENR_USART1EN;
	
	
	// Set baudrate
  USART1->BRR   = (468 << 4) | 0xC;                 
	
	// Configure USART2
  USART1->CR1   = ((   1UL <<  2) |       // Enable RX
                   (   1UL <<  3) |       // Enable TX
                   (   0UL << 12) );      // 1 start bit, 8 data bits
  USART1->CR2   = 0x0000;                 // 1 stop bit
  USART1->CR3   = 0x0000;                 // No flow control
  for (i = 0; i < 0x1000; i++) __NOP();   // Avoid unwanted output

  USART1->CR1 |= USART_CR1_UE;      			// Enable USART
}


int SendChar (int ch)  
{

  while (!(USART1->SR & USART_SR_TXE));
  USART1->DR = (ch & 0x1FF);
  return (ch);
}


int GetChar(void)  
{
  while (!(USART1->SR & USART_SR_RXNE));
  return ((int)(USART1->DR & 0x1FF));
}
