#include "stm32f10x.h"

void SystemInit(void)
{
	// Enable Prefetch Buffer
	FLASH->ACR |= FLASH_ACR_PRFTBE;
    // Flash 2 wait state 
  FLASH->ACR = (FLASH->ACR & ~FLASH_ACR_LATENCY) | FLASH_ACR_LATENCY_2; 

	// Enable HSE 
	RCC->CR |= RCC_CR_HSEON;
	while (RCC->CR & RCC_CR_HSERDY == 0);
							
  	// PREDIV1 source = HSE
	RCC->CFGR &= ~RCC_CFGR_PPRE1;

	// PLLSRC = PREDIV1
	RCC->CFGR |= RCC_CFGR_PLLSRC;
							  
	// PLL = PREDIV1 * 9 => SYSCLK = 72 MHz
	RCC->CFGR = (RCC->CFGR & ~RCC_CFGR_PLLMULL) | RCC_CFGR_PLLMULL_2 | RCC_CFGR_PLLMULL_1 | RCC_CFGR_PLLMULL_0;
							  
	// PLL enable
	RCC->CR |= RCC_CR_PLLON;
	while ((RCC->CR & RCC_CR_PLLRDY) == 0);

    RCC->CFGR = (RCC->CFGR & ~RCC_CFGR_SW) | RCC_CFGR_SW_PLL;
	while((RCC->CFGR & RCC_CFGR_SWS) != RCC_CFGR_SWS_PLL);

	// Config SysTick
	SysTick->LOAD = 1000000;
	SysTick->CTRL |= SysTick_CTRL_ENABLE | SysTick_CTRL_TICKINT;
}


void SysTick_Handler()
{
	char buffer[2];
	ReadTemp(buffer);
	
	// Packet beginning 
	SendChar(0xF0);
	
	// Temp. data
	SendChar(buffer[0]);
	SendChar(buffer[1]);
	
}

void main()
{
		InitSPI();
		USART1_Init();
	
		while(1)
		{
		}
}